#!/usr/bin/perl

require "cource.txt";

&parseArgument;

sub parseArgument {
	if($ENV{'REQUEST_METHOD'} eq "GET") {
		$buffer = $ENV{'QUERY_STRING'};
    } 
	else {
        read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    }

    @pairs = split(/&/,$buffer);
    foreach $pair( @pairs ) {
        ($name,$value)=split(/=/,$pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		unless ($name eq 'comments') {
				$value =~ s/<([^>]|\n)*>//g;
		}

        $FORM{$name} = $value;
    }

	&selectAction;
}

sub selectAction{
	&get_conf;
	if($FORM{'action'} eq "") {
		&admin_login;
	}
	elsif($FORM{'action'} eq "admin_area") {
		&adminform;
	}
	elsif($FORM{'action'} eq "admin_conf") {
		&admin_conf;	
	}
	elsif($FORM{'action'} eq "admin_login") {
		&admin_login;
	}
	elsif($FORM{'action'} eq "notify_all") {
		if(($FORM{'subject'} ne "") && ($FORM{'comment'} ne "")) {
			&notify_all;
		}
		else{
			&err_mail;
		}
	}
	elsif($FORM{'action'} eq "add_profile") {
		if(($FORM{'name'} ne "") && ($FORM{'email'} ne "") && ($FORM{'passwd'} ne "")) {
			&add_profile;
		}
		else {
			&error;
		}
	}
	elsif($FORM{'action'} eq "unlink") {
		&unlink_profile;
	}
	elsif($FORM{'action'} eq "loginok") {
		if($FORM{'passwd'} eq "") {
			&error_pass;
		}
		&loginok;
	}
	elsif($FORM{'action'} eq "conf_chg") {
        &conf_chg;
    }
	else {
		&admin_login;
	}
}

sub get_conf{
    open(CONF,"<$main_dir/conf.txt");
    $conf_list = <CONF>;
    close(CONF);
    @conf = split(/\|/,$conf_list);
	$admin_email = $conf[0];
	$admin_pass = $conf[1];
    $move_page = $conf[2];
	&put_conf;
}

sub put_conf {
    open(CONF,">$main_dir/conf.txt");
    print CONF "$admin_email|$admin_pass|$move_page";
    close(CONF);
}

sub head {
	print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<head><title>Sepal's login</title></head>\n";
    print "<style type='text/css'>\n";
    print "<!--\n";
    print "BODY, table, tr, td{\n";
    print "  font-family: , , ü, verdana, arial, helvetica, sans-serif;\n";
    print "  font-size: 10pt;\n";
    print "  }\n";
	print " A:link    {font:10pt ;color:#0087CB;text-decoration:none;}\n";
	print " A:visited {font:10pt ;color:#0087CB;text-decoration:none;color:$font_color;}\n";
	print " A:active  {color:#8FFF8A;font:10pt ;}\n";
	print " A:hover  {color:red;text-decoration:underline;}\n";
    print "-->\n";
    print "</style>\n" ;
	print"<body bgcolor=white>\n";
    print"<center>\n";
    print"<img src=$img_url/admin.gif border=0><p>\n";
}

sub foot {
	print "</center></body></html>\n";
	exit;
}

sub adminform {
  &get_conf;
  &head;

	open(LIST,"$main_dir/profile.txt");$x=0;
	@addresses=<LIST>;

	close(LIST);

	print "<form method=post action=admin.pl>\n";
	print "<input type=hidden name=action value=unlink>\n";
	print "<table border=0 cellpadding=3 cellspacing=0 width=300><tr><td>ڵϵ ȸ</td><td><SELECT NAME=\"profile\">\n";

	foreach $member(@addresses)
	{
		@name = split(/\|/,$member);
		print "<OPTION>$name[2]\n";
		$x++;
	}

		print "</SELECT></td><td><INPUT TYPE=\"submit\" VALUE=\"ϱ\" style=\"height:20px;background-color:#F2F2F2;border-color:black\"></td></tr></table></form><p>\n";
		print "<font color=red>$x</font>  ȸ ϵǾϴ.\n";
	
print <<START;
<form method=post action=./admin.pl>
<input type=hidden name=action value=add_profile>
<div align=center><table border=0 cellpadding=1 cellspacing=1 bgcolor=#EBFAFF>
<tr><td width=60 align=center><p><font face=ü size=2> &nbsp;&nbsp;</font></td>
<td width=200 colspan=2><p><font face=ü size=2><input type=text name=name size=20 maxlength=15 style="background-color:#F2F2F2;border:1 solid #000000"></font></td></tr>
<tr><td width=60 align=center><p><font face=ü size=2>e-mail</font></td><td width=200 colspan=2><p><font face=ü size=2><input type=text name=email size=20 maxlength=40 style="background-color:#F2F2F2;border:1 solid #000000"></font></td></tr>
<tr><td width=60 align=center><p><font face=ü size=2>йȣ</font></td><td width=60><p><font face=ü size=2><input type=password name=passwd size=8 style="background-color:#F2F2F2;border:1 solid #000000"></font></td></tr>
<tr><td colspan=2 align=left><p><font face=ü size=2><input type=submit value="ϱ" style=\"height:20px;background-color:#F2F2F2;border-color:black\"></font></td></tr></table></div></form>
<p>
<center>
<a href=admin.pl>ǵư</a>
</center>
<FORM method=post action="admin.pl">
<input type=hidden name=action value=notify_all>
<p class=t><font class=g10> ȸ ü e-mail </font><BR>
 <INPUT TYPE=text NAME="subject" size=30 style="background-color:#F2F2F2;border-color:black"></font><BR>
<TEXTAREA NAME="comment" ROWS=13 COLS=55 style="background-color:#F2F2F2;border-color:black"></TEXTAREA><BR>
<INPUT TYPE="submit" VALUE="" style="height:22px;background-color:#F2F2F2;border-color:black"></form>
START

	&foot;	
}

sub admin_conf {
  &get_conf;
  &head;
    print "<p>&nbsp;<p>&nbsp;\n";
	print "<form method=post action=admin.pl>\n";
	print "<input type=hidden name=action value=conf_chg>\n";
	print "<table border=0 align=center cellpadding=1 cellspacing=0 bgcolor=black><tr><td>\n";
	print "<table border=0 width=100% cellpadding=3 cellspacing=0 bgcolor=#FFF7CF>\n";
	print "<tr><td align=right><font color=000000>[ĭ ״ νø  йȣ ]<br≯ <input type=text name=admin_email value=\"$admin_email\" size=20></td></tr>\n";
	print "<tr><td align=right>йȣ</font> <input type=password name=passad size=8>\n";
	print "&nbsp; <font color=000000>ٽԷ</font> <input type=password name=repassad size=8></td></tr>\n";
	print "<tr><td><font color=000000>αν   URL </font> <input type=text name=letsgo value=\"$move_page\" size=25><br></td></tr></table></td></tr></table><p>\n";
	print "<input type=submit value=ϱ style=\"background-color:#FFE29D;border:1 solid black;height:20\"> <input type=reset value=ٽþ style=\"background-color:#FFE29D;border:1 solid black;height:20\">\n";
	print "</form>\n";
	&foot;	
}

sub notify_all
{
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs)
	{
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$FORM{$name} = $value;
	}

	open(LIST,"$main_dir/profile.txt");
	@addresses=<LIST>;
	close(LIST);
	print "Content-type: text/html\n\n";
	print "<HTML>\n";
	print "<HEAD><TITLE>ӹϷ</TITLE></HEAD>\n";
	print "<BODY BGCOLOR=\"#FFFFFF\">\n";

	foreach $member(@addresses)
	{
		@email = split(/\|/, $member);
		$email = $email[1];
		open (MAIL, "|$mailprog $email") || die "Can't open $mailprog!\n";
		print MAIL "Subject:$FORM{'subject'}\n";
		print MAIL "From:Ȩ  < $admin_email >\n";
		print MAIL "To:$email\n";
		print MAIL "$FORM{'comment'}\n";
		close (MAIL);
		$x++;
	}
	
	$message="漺!!!   Ϸ߽~!!!<P>";

	print "<CENTER><H3>\n";
	print "$message\n";
	print "<A HREF=\"javascript:history.back()\">Back</A>\n";
	print "</H3></CENTER>\n";
	print "</BODY></HTML>\n";
}

sub error {
&head;
   print "<p>&nbsp;<H1><u><font color=#FFBCEF> Error!!! </font></u></H1>\n";
   print "̸, ̸, йȣ ݵ ž<br>  մϴ<p>\n";
   print "<a href=\"javascript:history.go(-1)\"> Back</a>\n";
&foot;	
}

sub admin_login {
	&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
<table border="0" cellpadding="3" cellspacing="0" width="430" bgcolor="#000000">
    <tr>
        <td width="740"><table border="0" cellpadding="3" cellspacing="0" width="100%"
             bgcolor="#F2F2F2">
                <tr>
                    <td width="730"><p align="center"><font size="2" color="#000000">  մϴ.<br> йȣ  ֽð Ȯ ư  
                        ּ.</font></td>
                </tr>
            </table></td>
    </tr>
</table>
<p>&nbsp;
<form method=post action=$admin_url>
<input type=hidden name=action value=loginok>
<table>
<tr><td>ID</td><td>
<input type=text name=id size=10 style="background-color:#F2F2F2;border:1 solid #000000">
</td></tr>
<tr><td>йȣ</td><td>
<input type=password name=passwd size=10 style="background-color:#F2F2F2;border:1 solid #000000">
</td></tr>
<tr>
<td>
<input type=submit value=\"Ȯ\" style="color:black;background-color:#F2F2F2;border:1 solid black;height:21px">
</td>
<td></form></td></tr>
</table>
START
&foot;
}

sub add_profile {
	$pass = $FORM{'passwd'};
	$cryptpass = crypt($pass,sp);
	$FORM{'passwd'} =  $cryptpass;
open(LIST,">>$main_dir/profile.txt");
print LIST "$FORM{'passwd'}|$FORM{'email'}|$FORM{'name'}\n";
close(LIST);
&go_back;
exit;
}


sub unlink_profile {
	open(LIST,"$main_dir/profile.txt");
	@addresses=<LIST>;
	close(LIST);
	if ($addresses[0] eq "") {
		&no_member;
	}
	$x=0;
	foreach $member(@addresses)	{
		&clean;
		@name = split(/\|/, $member);
		if ($FORM{'profile'} eq $name[2]) {
			&deletemember;
		}
		$x++;
	}
}

sub no_member{

	&head;
	print "<p>&nbsp;<H1><u>ϵ ȸ ϴ.</u></H1>\n";
	print "<p>ƹ  Ǿ  ʴϴ....<p>\n";
	print "<a href=\"javascript:history.go(-1)\"> Back</a>\n";
	&foot;	
	exit;
}

sub deletemember {
	@addresses[$x] = "";
	open(LIST,">$main_dir/profile.txt");
	foreach $member(@addresses) {
		&clean;
		unless($member eq "") {
			print LIST "$member\n";
		}
	}
	&go_back;
	exit;
}

sub clean
{
	chomp($member);
	$member=~ s/^\s+//;
	$member=~ s/\s+$//;
}

sub go_back {
	&adminform;
}

sub modify {
	&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
<p>&nbsp;
<form method=post action=$cgi_url>
ȯ漳<input type=radio name=action  value=admin_conf checked> &nbsp; &nbsp;
ȸ<input type=radio name=action  value=admin_area>
<p>
<table>
<tr><td><input type=submit value=Ȯ style="color:black;background-color:#F2F2F2;border:1 solid black;height:21px"></td><td></form></td></tr></table>
START
&foot;
}

sub loginok {
	$pass = $FORM{'passwd'};
	@separate = split(/\@/,$admin_email);
	$admin_id = $separate[0];
	$cryptpass = crypt($pass,sp);
	$FORM{'passwd'} =  $cryptpass;
	if($admin_id eq $FORM{'id'} && $admin_pass eq $FORM{'passwd'}) {
		&modify;
	}

	else {
		&error_pass;
	}
}

sub error_pass {
	&head;
	print "<H1><u>йȣ </u></H1>\n";
	print "йȣ Ʋ... ٽѹ õϽñ...<p>\n";
	print "ڷ ư ٽ õ Ͻʽÿ.<br><br>\n";
	print "<a href=\"javascript:history.go(-1)\"> Back</a>\n";
	&foot;	
}

sub err_mail {
	&head;
	print "<H1><u>ĭ ־</u></H1>\n";
	print "  ݵ ž... ٽѹ õϽñ...<p>\n";
	print "ڷ ư ٽ õ Ͻʽÿ.<br><br>\n";
	print "<a href=\"javascript:history.go(-1)\"> Back</a>\n";
	&foot;	
}
sub conf_chg {
	$ad_email = $FORM{'admin_email'};
	$passad = $FORM{'passad'};
	$repassad = $FORM{'repassad'};
	$letsgo = $FORM{'letsgo'};
	if($ad_email eq "") {
		$ad_email = $admin_email;
	}
	if ($passad ne ""){
		if ($passad eq $repassad){
			$cryptpass = crypt($passad,sp);
			close(PASS);
		}
		else {
			&head;
			print "<center>\n";
			print "<form><hr width=300 noshade>\n";
			print "йȣ Ʋϴ.\n";
			print "<hr width=300 noshade>\n";
			print "<INPUT type=button value=ٽۼ onClick=history.go(-1) style=\"background-color:#ffffff;border:1 solid black;height:20\"></form>\n";
			&foot
		}
	}
	else{
		$cryptpass = $admin_pass;
	}
  open(CFG,">$main_dir/conf.txt");
  print CFG "$ad_email|$cryptpass|$letsgo|\n";
  close(CFG);

	&head;
	print "<center>\n";
	print "<META HTTP-EQUIV=Refresh CONTENT=0;URL=admin.pl>\n";
	print "<p>&nbsp;<p>&nbsp;<p>&nbsp;<hr width=300 noshade>\n";
	print "ȯȭ  žϴ.\n";
	print "<hr width=300 noshade>\n";
	&foot
}